/**
 例外の委譲
 @version $Id: ExceptionDelegate.java,v 1.1 2005-06-14 08:02:06+09 kaiya Exp kaiya $
 */
public class ExceptionDelegate{

	/** 
	 引数として与えられた配列の5番目の要素を返す．
	 引数の長さが足りない場合，自分では対処せず，
	 呼び出しもとに例外を投げて対処を委譲(たらいまわし)する．
	*/
	public String five(String[] a) throws Exception{
		String r=null;
		try{
			r=a[5-1];
		}catch(Exception e){
			System.err.println("Oh No! I (five) can't handle!");
			throw e;
		}
		return r;
	}

	/** テストプログラム */
	public static void main(String[] args){
		
		String[] list=new String[0];
		ExceptionDelegate ed=new ExceptionDelegate();

		for(int i=0; true; i++){
			try{
				System.out.println(ed.five(list));
				break; // ココでループから抜ける．
			}catch(Exception e){ // 例外処理とは本来，再処理できるように状況復帰するのが役目．
				System.err.println("Yes, I (main) extend the args to "+(i+1));
				list=new String[i+1];
				list[i]="sakana";
			}
		}
	}
}
