/**
 複数種類の例外を個別補足する例
 */
public class Catches{
	/** ダミー */
	int x;
	
	public static void main(String[] args){
		try{
			int x=10/0;
		}catch(ArrayIndexOutOfBoundsException e){ // 配列の範囲超え
			System.err.println(e);
		}catch(ArithmeticException e){ // 計算例外，ゼロ割とか
			System.err.println(e);
		}catch(NullPointerException e){ // 何も指してないリファレンスへのアクセス
			System.err.println(e);
		}finally{
			System.err.println("finally in 10/0");
		}

		try{
			System.out.println(args[10]); // 実行時には引数が無い場合
		}catch(ArrayIndexOutOfBoundsException e){ // 配列の範囲超え
			System.err.println(e);
		}catch(ArithmeticException e){ // 計算例外，ゼロ割とか
			System.err.println(e);
		}catch(NullPointerException e){ // 何も指してないリファレンスへのアクセス
			System.err.println(e);
		}finally{
			System.err.println("finally in args[10]");
		}

		try{
			Catches c=null;
			System.out.println(c.x);
		}catch(ArrayIndexOutOfBoundsException e){ // 配列の範囲超え
			System.err.println(e);
		}catch(ArithmeticException e){ // 計算例外，ゼロ割とか
			System.err.println(e);
		}catch(NullPointerException e){ // 何も指してないリファレンスへのアクセス
			System.err.println(e);
		}finally{
			System.err.println("finally in null pointer");
		}

		try{
			System.out.println("No Exception"); // ココではわざと例外なしにしてます．
		}catch(ArrayIndexOutOfBoundsException e){ // 配列の範囲超え
			System.err.println(e);
		}catch(ArithmeticException e){ // 計算例外，ゼロ割とか
			System.err.println(e);
		}catch(NullPointerException e){ // 何も指してないリファレンスへのアクセス
			System.err.println(e);
		}finally{
			System.err.println("finally in no exceptions"); // でも，ここは実行されますね．
		}

	}
}
