/**
 計算結果を例外として返す変なコードの例．
 @version $Id: CrazyAdd.java,v 1.1 2005-06-14 06:42:04+09 kaiya Exp kaiya $
 */
public class CrazyAdd{

	/** 
	 例外だって，メソッド呼び出し側に結果を通知するのにつかえるじゃん，
	 ってことで，投げられる例外に計算(足し算)結果が埋め込まれているメソッド．
	 これでメソッドの返り値なんていりませんね(笑)
	 @throws 足し算の計算結果がメンバーresultとして埋め込まれている．
	*/
	public void add(int x, int y) throws AddException {
		AddException a=new AddException();
		a.result=x+y;
		throw a;
	}

	/** とりえあず実行例をココに埋める */
	public static void main(String[] args){
		CrazyAdd a=new CrazyAdd();
		try{
			a.add(4, 5); // 足し算をしますが，
		}catch(AddException e){
			System.out.println(e.result); // 結果は例外に内包されてます
		}
	}
}
